/*
  nur base64: 485520k
  mit compress: 418896k
*/


#include <stdio.h>
#include <stdlib.h>
#include <libpq-fe.h>
#include <qsqlquery.h>
#include <qcstring.h>
#include "../global.h"
#include "libpq/libpq-fs.h"

// void writebuf(QByteArray &buf);
void exit_nicely(PGconn *conn);


bool check(PGconn *conn, QString table, QString linkno, QString var, QString oid) {
  PGresult *res;

  res=PQexec(conn, "select no from "+table+" where no="+linkno);
  if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
    {
      fprintf(stderr, "res: command failed\n");
      PQclear(res);
      exit_nicely(conn);
    }
  int cnt=PQntuples(res);
  PQclear(res);
  if(cnt>0) {
    res=PQexec(conn, "update link set "+var+"=tabid('"+table+"') where oid="+oid);
    if (!res || PQresultStatus(res) != PGRES_COMMAND_OK)
      {
	fprintf(stderr, "res: command failed\n");
	PQclear(res);
	exit_nicely(conn);
      }
    PQclear(res);
    return false;
  }
  return true;
}
  

void
exit_nicely(PGconn *conn)
{
  PQfinish(conn);
  exit(1);
}

main()
{
  char *pghost,
    *pgport,
    *pgoptions,
    *pgtty;
  char       *dbName;
  int         nFields;
  int         i,
    j;
  
  PGconn     *conn;
  PGresult   *recs;
  
  
  pghost = NULL;              /* host name of the backend server */
  pgport = NULL;              /* port of the backend server */
  pgoptions = NULL;           /* special options to start up the backend
			       * server */
  pgtty = NULL;               /* debugging tty for the backend server */
  dbName = "kaspadev";
  
  conn = PQsetdb(pghost, pgport, pgoptions, pgtty, dbName);

  if (PQstatus(conn) == CONNECTION_BAD)
    {
      fprintf(stderr, "Connection to database '%s' failed.\n", dbName);
      fprintf(stderr, "%s", PQerrorMessage(conn));
      exit_nicely(conn);
    }
  
  recs = PQexec(conn, "select obj_1, obj_2, oid from link"); 
  if (!recs || PQresultStatus(recs) != PGRES_TUPLES_OK)
    {
      fprintf(stderr, "recs: command failed\n");
      PQclear(recs);
      exit_nicely(conn);
    }

  for (i=0; i<PQntuples(recs); i++)
    {
      if(QString(PQgetvalue(recs, i, 0)).isEmpty() or QString(PQgetvalue(recs, i, 1)).isEmpty())
	continue;
      fprintf(stderr, "Processing link %i\n", i);
      //      fprintf(stderr, "a=%s b=%s", PQgetvalue(recs, i, 0), PQgetvalue(recs, i, 1));
      check(conn, "author", PQgetvalue(recs, i, 0), "tab_1", PQgetvalue(recs, i, 2)) &&
	check(conn, "note", PQgetvalue(recs, i, 0), "tab_1", PQgetvalue(recs, i, 2)) &&
	check(conn, "part", PQgetvalue(recs, i, 0), "tab_1", PQgetvalue(recs, i, 2)) &&
	check(conn, "publication", PQgetvalue(recs, i, 0), "tab_1", PQgetvalue(recs, i, 2)) &&
	check(conn, "partdata", PQgetvalue(recs, i, 0), "tab_1", PQgetvalue(recs, i, 2));
      
      check(conn, "author", PQgetvalue(recs, i, 1), "tab_2", PQgetvalue(recs, i, 2)) &&
	check(conn, "note", PQgetvalue(recs, i, 1), "tab_2", PQgetvalue(recs, i, 2)) &&
	check(conn, "part", PQgetvalue(recs, i, 1), "tab_2", PQgetvalue(recs, i, 2)) &&
	check(conn, "publication", PQgetvalue(recs, i, 1), "tab_2", PQgetvalue(recs, i, 2)) &&
	check(conn, "partdata", PQgetvalue(recs, i, 1), "tab_2", PQgetvalue(recs, i, 2));
    }
  /* close the connection to the database and cleanup */
  PQfinish(conn);
  
  return 0;
}
