/*
  nur base64: 485520k
  mit compress: 418896k
*/


#include <stdio.h>
#include <stdlib.h>
#include <libpq-fe.h>
#include <qsqlquery.h>
#include <qcstring.h>
#include <qapplication.h>
#include <kmdcodec.h>
#include <qfile.h>
#include "../global.h"
#include "libpq/libpq-fs.h"

// void writebuf(QByteArray &buf);
void exit_nicely(PGconn *conn);

void writebuf(PGconn *conn, QByteArray b, int chunkno, char* fileno) {
  PGresult *ins;
  size_t len;

  QCString b64=KCodecs::base64Encode(qCompress(b));
  
  QFile f("/tmp/writebuf"+QString().setNum(chunkno));
  f.open(IO_WriteOnly);
  f.writeBlock(b);
  f.close();
  

  ins=PQexec(conn, "insert into file (chunk, partdata_no, chunk_no) values ('"+QCString(b64)+"', "+QCString(fileno)+", "+QCString().setNum(chunkno)+")");
  if (!ins || PQresultStatus(ins) != PGRES_COMMAND_OK) {
    fprintf(stderr, "res: command failed\n");
    PQclear(ins);
    exit_nicely(conn);
  }
  PQclear(ins);
}

void
exit_nicely(PGconn *conn)
{
  PQfinish(conn);
  exit(1);
}

main()
{
  char *pghost,
    *pgport,
    *pgoptions,
    *pgtty;
  char       *dbName;
  int         nFields;
  int         i,
    j;
  
  PGconn     *conn;
  PGresult   *recs, *res;
  
  
  pghost = NULL;              /* host name of the backend server */
  pgport = NULL;              /* port of the backend server */
  pgoptions = NULL;           /* special options to start up the backend
			       * server */
  pgtty = NULL;               /* debugging tty for the backend server */
  dbName = "kaspadev";
  
  /* make a connection to the database */
  conn = PQsetdb(pghost, pgport, pgoptions, pgtty, dbName);
  
  /*
   * check to see that the backend connection was successfully made
   */
  if (PQstatus(conn) == CONNECTION_BAD)
    {
      fprintf(stderr, "Connection to database '%s' failed.\n", dbName);
      fprintf(stderr, "%s", PQerrorMessage(conn));
      exit_nicely(conn);
    }
  
  /* debug = fopen("/tmp/trace.out","w"); */
  /* PQtrace(conn, debug);  */
  
  /* start a transaction block */
  recs = PQexec(conn, "select no, filename from partdata");
  if (!recs || PQresultStatus(recs) != PGRES_TUPLES_OK)
    {
      fprintf(stderr, "recs: command failed\n");
      PQclear(recs);
      exit_nicely(conn);
    }

  for (i=0; i<PQntuples(recs); i++)
    {
      res=PQexec(conn, QCString("select file from partdata where no=")+PQgetvalue(recs, i, 0));
      if (!res || PQresultStatus(res) != PGRES_TUPLES_OK)
	{
	  fprintf(stderr, "res: command failed\n");
	  PQclear(res);
	  exit_nicely(conn);
	}
      fprintf(stderr, "Processing file %i\n", i);
      QByteArray buf;
      KCodecs::base64Decode(QCString(PQgetvalue(res, 0, 0)), buf);
      PQclear(res);

      
      QFile f("/tmp/orig");
      f.open(IO_WriteOnly);
      f.writeBlock(buf);
      f.close();
      
  
      #define bufsize 1000000
      QByteArray chunk(bufsize);
      int j=0;
      while((j+1)*bufsize<buf.size()) {
	memcpy(chunk.data(), buf.data()+j*bufsize, bufsize);
	j++;
	fprintf(stderr, "Writing chunk %i\n", j);
	writebuf(conn, chunk, j, PQgetvalue(recs, i, 0));
      }
      chunk.resize(buf.size()-j*bufsize);
      memcpy(chunk.data(), buf.data()+j*bufsize, buf.size()-j*bufsize);
      writebuf(conn, chunk, j+1, PQgetvalue(recs, i, 0));
    }
  /* close the connection to the database and cleanup */
  PQfinish(conn);
  
  return 0;
}

/*

int main(int argc, char **argv) {
  QApplication a(argc, argv);	
  createConnection("qt_sql_default_connection");
  
  QSqlQuery p("select no, filename from partdata where no=15317");
  while(p.next()) {
    debug("Processing "+p.value(1).toString());
    QSqlQuery q("select file from partdata where no="+p.value(0).toString());
    q.first();
    QByteArray buf;
    KCodecs::base64Decode(q.value(0).toCString(), buf);
    q.~QSqlQuery();

    QSqlQuery r;
    //    r.prepare("update file set file=? where no="+p.value(0).toString());
    //    r.bindValue(0, qCompress(buf));

    r.prepare("update file set file=encode(?, 'base64') where no="+p.value(0).toString());
    r.bindValue(0, qCompress(buf));

    debug("Buffer:"+QString().setNum(buf.count()));
    debug("Buffer:"+QString().setNum(qCompress(buf).count()));
    
    // r.bindValue(0, qCompress(KCodecs::base64Encode(q.value(0).toByteArray(), false)));;
    // r.bindValue(0, qCompress(q.value(0).toByteArray()));
    r.exec();
  }
}

*/
