create table search_wordlist (string text, unique(oid));
create index search_wordlist_index on search_wordlist(string);
create table search_stopword (word text);
create table search_index (string oid, id integer, tab integer);
create table search_parent (id oid, parent oid);
create index search_index_str on search_index(string);


create or replace function tabid(varchar) returns integer as '
declare
	tab alias for $1;
begin
  if tab=''author'' then
	return 1;
  elsif tab=''publication'' then
	return 2;
  elsif tab=''part'' then
	return 3;
  elsif tab=''partdata'' then
	return 4;
  elsif tab=''file'' then
	return 5;
  elsif tab=''note'' then
	return 6;
  elsif tab=''link'' then
	return 7;
  elsif tab=''journal'' then
	return 8;
  elsif tab=''publisher'' then
	return 9;
  elsif tab=''project'' then
	return 10;
  elsif tab=''search_index'' then
	return 11;
  elsif tab=''search_parent'' then
	return 12;
  elsif tab=''search_stopword'' then
	return 13;
  elsif tab=''search_wordlist'' then
	return 14;
  end if;
  raise EXCEPTION ''tabid(): Unknown table "%"'', tab;
  return NULL;
end;
' language 'plpgsql';


CREATE TABLE file (
    "no" integer DEFAULT nextval('kaspa_seq'::text),
    partdata_no integer DEFAULT 0,
    chunk text DEFAULT '',
    chunk_no integer DEFAULT 0,
    primary key(no)
);

CREATE TABLE project (
    "no" integer DEFAULT nextval('kaspa_seq'::text),
    title text DEFAULT '',
    memo text DEFAULT '',
    created timestamp with time zone DEFAULT "timestamp"('now'::text),
    modified timestamp with time zone DEFAULT "timestamp"('now'::text),
    primary key(no)
);


CREATE TABLE project_bibliography (
    "no" integer DEFAULT nextval('kaspa_seq'::text),
    project_no int DEFAULT 0,
    tab_no int DEFAULT 0,
    id_no int DEFAULT 0,
    primary key(no)
);


insert into search_stopword values('de');
insert into search_stopword values('la');
insert into search_stopword values('le');
insert into search_stopword values('et');
insert into search_stopword values('les');
insert into search_stopword values('des');
insert into search_stopword values('en');
insert into search_stopword values('un');
insert into search_stopword values('du');
insert into search_stopword values('une');
insert into search_stopword values('que');
insert into search_stopword values('est');
insert into search_stopword values('pour');
insert into search_stopword values('qui');
insert into search_stopword values('dans');
insert into search_stopword values('a');
insert into search_stopword values('par');
insert into search_stopword values('plus');
insert into search_stopword values('pas');
insert into search_stopword values('au');
insert into search_stopword values('sur');
insert into search_stopword values('ne');
insert into search_stopword values('se');
insert into search_stopword values('ce');
insert into search_stopword values('sont');
insert into search_stopword values('ou');
insert into search_stopword values('avec');
insert into search_stopword values('son');
insert into search_stopword values('il');
insert into search_stopword values('aux');
insert into search_stopword values('en');
insert into search_stopword values('cette');
insert into search_stopword values('ont');
insert into search_stopword values('ses');
insert into search_stopword values('mais');
insert into search_stopword values('comme');
insert into search_stopword values('on');
insert into search_stopword values('tout');
insert into search_stopword values('nous');
insert into search_stopword values('sa');
insert into search_stopword values('mais');
insert into search_stopword values('fait');
insert into search_stopword values('aussi');
insert into search_stopword values('leur');
insert into search_stopword values('bien');
insert into search_stopword values('peut');
insert into search_stopword values('ces');
insert into search_stopword values('y');
insert into search_stopword values('deux');
insert into search_stopword values('a');
insert into search_stopword values('ans');
insert into search_stopword values('l');
insert into search_stopword values('encore');
insert into search_stopword values('d');
insert into search_stopword values('pour');
insert into search_stopword values('donc');
insert into search_stopword values('moins');
insert into search_stopword values('sans');
insert into search_stopword values('et');
insert into search_stopword values('si');
insert into search_stopword values('entre');
insert into search_stopword values('un');
insert into search_stopword values('ce');
insert into search_stopword values('faire');
insert into search_stopword values('elle');
insert into search_stopword values('peu');
insert into search_stopword values('vous');
insert into search_stopword values('une');
insert into search_stopword values('on');
insert into search_stopword values('dont');
insert into search_stopword values('lui');
insert into search_stopword values('dans');
insert into search_stopword values('de');
insert into search_stopword values('leurs');
insert into search_stopword values('der');
insert into search_stopword values('die');
insert into search_stopword values('und');
insert into search_stopword values('in');
insert into search_stopword values('den');
insert into search_stopword values('von');
insert into search_stopword values('zu');
insert into search_stopword values('das');
insert into search_stopword values('mit');
insert into search_stopword values('sich');
insert into search_stopword values('des');
insert into search_stopword values('auf');
insert into search_stopword values('ist');
insert into search_stopword values('im');
insert into search_stopword values('dem');
insert into search_stopword values('nicht');
insert into search_stopword values('ein');
insert into search_stopword values('die');
insert into search_stopword values('eine');
insert into search_stopword values('als');
insert into search_stopword values('auch');
insert into search_stopword values('es');
insert into search_stopword values('an');
insert into search_stopword values('werden');
insert into search_stopword values('aus');
insert into search_stopword values('er');
insert into search_stopword values('hat');
insert into search_stopword values('sie');
insert into search_stopword values('nach');
insert into search_stopword values('wird');
insert into search_stopword values('bei');
insert into search_stopword values('einer');
insert into search_stopword values('der');
insert into search_stopword values('um');
insert into search_stopword values('am');
insert into search_stopword values('sind');
insert into search_stopword values('noch');
insert into search_stopword values('wie');
insert into search_stopword values('einem');
insert into search_stopword values('einen');
insert into search_stopword values('das');
insert into search_stopword values('so');
insert into search_stopword values('sie');
insert into search_stopword values('zum');
insert into search_stopword values('war');
insert into search_stopword values('haben');
insert into search_stopword values('nur');
insert into search_stopword values('oder');
insert into search_stopword values('aber');
insert into search_stopword values('vor');
insert into search_stopword values('zur');
insert into search_stopword values('bis');
insert into search_stopword values('mehr');
insert into search_stopword values('durch');
insert into search_stopword values('man');
insert into search_stopword values('sein');
insert into search_stopword values('wurde');
insert into search_stopword values('sei');
insert into search_stopword values('in');
insert into search_stopword values('hatte');
insert into search_stopword values('kann');
insert into search_stopword values('gegen');
insert into search_stopword values('vom');
insert into search_stopword values('schon');
insert into search_stopword values('wenn');
insert into search_stopword values('habe');
insert into search_stopword values('seine');
insert into search_stopword values('ihre');
insert into search_stopword values('dann');
insert into search_stopword values('unter');
insert into search_stopword values('wir');
insert into search_stopword values('soll');
insert into search_stopword values('ich');
insert into search_stopword values('eines');
insert into search_stopword values('es');
insert into search_stopword values('diese');
insert into search_stopword values('dieser');
insert into search_stopword values('wieder');
insert into search_stopword values('keine');
insert into search_stopword values('seiner');
insert into search_stopword values('worden');
insert into search_stopword values('und');
insert into search_stopword values('will');
insert into search_stopword values('zwischen');
insert into search_stopword values('im');
insert into search_stopword values('immer');
insert into search_stopword values('ein');
insert into search_stopword values('was');
insert into search_stopword values('sagte');
insert into search_stopword values('the');
insert into search_stopword values('of');
insert into search_stopword values('to');
insert into search_stopword values('and');
insert into search_stopword values('a');
insert into search_stopword values('in');
insert into search_stopword values('for');
insert into search_stopword values('is');
insert into search_stopword values('the');
insert into search_stopword values('that');
insert into search_stopword values('on');
insert into search_stopword values('said');
insert into search_stopword values('with');
insert into search_stopword values('be');
insert into search_stopword values('was');
insert into search_stopword values('by');
insert into search_stopword values('as');
insert into search_stopword values('are');
insert into search_stopword values('at');
insert into search_stopword values('from');
insert into search_stopword values('it');
insert into search_stopword values('has');
insert into search_stopword values('an');
insert into search_stopword values('have');
insert into search_stopword values('will');
insert into search_stopword values('or');
insert into search_stopword values('its');
insert into search_stopword values('he');
insert into search_stopword values('not');
insert into search_stopword values('were');
insert into search_stopword values('which');
insert into search_stopword values('this');
insert into search_stopword values('but');
insert into search_stopword values('can');
insert into search_stopword values('more');
insert into search_stopword values('his');
insert into search_stopword values('been');
insert into search_stopword values('would');
insert into search_stopword values('about');
insert into search_stopword values('their');
insert into search_stopword values('also');
insert into search_stopword values('they');
insert into search_stopword values('had');
insert into search_stopword values('than');
insert into search_stopword values('up');
insert into search_stopword values('who');
insert into search_stopword values('in');
insert into search_stopword values('one');
insert into search_stopword values('you');
insert into search_stopword values('new');
insert into search_stopword values('a');
insert into search_stopword values('i');
insert into search_stopword values('other');
insert into search_stopword values('all');
insert into search_stopword values('two');
insert into search_stopword values('s');
insert into search_stopword values('but');
insert into search_stopword values('it');
insert into search_stopword values('into');
insert into search_stopword values('u');
insert into search_stopword values('mr');
insert into search_stopword values('some');
insert into search_stopword values('when');
insert into search_stopword values('out');
insert into search_stopword values('last');
insert into search_stopword values('only');
insert into search_stopword values('after');
insert into search_stopword values('first');
insert into search_stopword values('says');
insert into search_stopword values('he');
insert into search_stopword values('no');
insert into search_stopword values('over');
insert into search_stopword values('we');
insert into search_stopword values('could');
insert into search_stopword values('if');
insert into search_stopword values('such');
insert into search_stopword values('this');
insert into search_stopword values('most');
insert into search_stopword values('use');
insert into search_stopword values('because');
insert into search_stopword values('any');
insert into search_stopword values('data');
insert into search_stopword values('there');
insert into search_stopword values('them');
insert into search_stopword values('may');
insert into search_stopword values('so');
insert into search_stopword values('many');

drop function fti() cascade;
create function fti() returns opaque as '/home/jan/literature/fulltextindex/fti.so' language 'C';
create trigger part_fti_trigger after update or insert or delete on part for each row execute procedure fti(memo, no);
create trigger publ_fti_trigger after update or insert or delete on publication for each row execute procedure fti(memo, no);
create trigger author_fti_trigger after update or insert or delete on author for each row execute procedure fti(memo, no);
create trigger note_fti_trigger after update or insert or delete on note for each row execute procedure fti(memo, no);
create trigger partdata_fti_trigger after update or insert or delete on partdata for each row execute procedure fti(astext, no);
