/***************************************************************************
 *                                                                         *
 *   author.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "authorform.h"
#include "readwriteformbase.h"

class QToolBar;
class FillLinkListBox;
class MainWindow;
class QCloseEvent;
class Author: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Author(const Author&);
    Author& operator=(const Author&);

    protected:
    AuthorForm *authorform;
    QToolBar *toolbar;
    QAction *insertNoteAction;
    QAction *createNoteAction;    
    QAction *deleteNoteAction;
    QAction *insertPublicationAction;
    QAction *createPublicationAction;    
    QAction *deletePublicationAction;
    QAction *insertPartAction;
    QAction *deletePartAction;

    FillLinkListBox *filllink;
    FillLinkListBox *fillpubl;
    FillLinkListBox *fillpart;
    bool setData();
    
    void initToolBar();
    
    public:
    Author(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Author();
    
    protected slots:    
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    virtual void insertNote();
    virtual void deleteNote();
    virtual void createNote();    
    virtual void insertPublication();
    virtual void deletePublication();
    virtual void createPublication();    
    virtual void insertPart();
    virtual void deletePart();
};
