/***************************************************************************
 *                                                                         *
 *   authorlinklistbox.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "authorlinklistbox.h"
#include <qlistview.h>
#include "liturl.h"
#include "linklistboxitem.h"

AuthorLinkListBox::AuthorLinkListBox(QWidget *parent, const char *name ) :  
  LinkListBox(parent,name) {
    
    pop.insertItem("Move Author Up", this, SLOT(slotUp()));
    pop.insertItem("Move Author Down", this, SLOT(slotDown()));
    setSorting(-1);
  }

void AuthorLinkListBox::slotUp() {
  if(!currentItem() || !currentItem()->itemAbove()) return;
  order_modified=true;
  if(currentItem()->itemAbove()->itemAbove())
    currentItem()->moveItem(currentItem()->itemAbove()->itemAbove());
  else
    currentItem()->itemAbove()->moveItem(currentItem());
}

void AuthorLinkListBox::slotDown() {
  if(!currentItem() || !currentItem()->itemBelow()) return;
  order_modified=true;
  //  takeItem(currentItem());
  currentItem()->moveItem(currentItem()->itemBelow());
}

QValueList<LitUrl> AuthorLinkListBox::authorPos() {
  QValueList<LitUrl> l;
  QListViewItem *i=firstChild();
  while(i) {
    LinkListBoxItem *item=dynamic_cast<LinkListBoxItem*>(i);
    if(item)
      l.append(item->url());
    i=i->nextSibling();
  }
  return l;
}

bool AuthorLinkListBox::modified() {
  return order_modified;
}
