/***************************************************************************
 *                                                                         *
 *   authorlinklistbox.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef AuthorLinkListBox_h
#define AuthorLinkListBox_h
#include <linklistbox.h>
#include <qvaluelist.h>

class LitUrl;
class LinkListBoxItem;

class AuthorLinkListBox: public LinkListBox  {
  Q_OBJECT
    
private:
  AuthorLinkListBox(const AuthorLinkListBox&);
  AuthorLinkListBox& operator=(const AuthorLinkListBox&);
  
  bool order_modified;
  
protected slots:
  void slotUp();
  void slotDown();
  
public:
  AuthorLinkListBox(QWidget *parent=0, const char *name=0);
  QValueList<LitUrl> authorPos();
  bool modified();
};
#endif
