/***************************************************************************
 *                                                                         *
 *   authoroverview.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "authoroverview.h"
#include "readonlyformbase.h"
#include "linklistbox.h"
#include "linklistboxitem.h"
#include <qglobal.h>
#include <qlabel.h>
#include <qsqlquery.h>
#include <qlayout.h>

AuthorOverview::AuthorOverview(LitUrl u, QObject *receiver, QString slot, QWidget *parent, const char *name): 
	ReadOnlyFormBase(u, receiver, slot, parent, name) {
    overviewform=new OverviewForm(this, "authoroverviewform");
    QHBoxLayout *l=new QHBoxLayout(this);
    l->addWidget(overviewform);
    Q_ASSERT(overviewform);  
    setData();
}

bool AuthorOverview::setData() {
    overviewform->title->setText("Authors");
    overviewform->linklistbox->clear();
    overviewform->linklistbox->setColumnText(0, "Names");
    QSqlQuery query("select firstname, lastname, no from author order by lastname");
    
    while(query.next()) {
	new LinkListBoxItem(overviewform->linklistbox, query.value(1).toString()+", "+query.value(0).toString(), LitUrl("lit://author/author?no="+query.value(2).toString()));
      setValid(true);
    }
    return true;
}

AuthorOverview::~AuthorOverview() {
}
