/***************************************************************************
 *                                                                         *
 *   bibliography.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "bibliographyform.h"
#include "readwriteformbase.h"

class QToolBar;
class MainWindow;
class QCloseEvent;
class Bibliography: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Bibliography(const Bibliography&);
    Bibliography& operator=(const Bibliography&);

    protected:
    BibliographyForm *biblioform;
    QToolBar *toolbar;
    QAction *showPublAction;
    bool setData();
    
    void initToolBar();
    void insertBibtexField(QString label, QString field, QFrame *frame, QSqlForm *form);
    
    public:
    Bibliography(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Bibliography();
    
    protected slots:    
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    virtual void showPubl();
    virtual void chooseOrgPublisher();
    virtual void generateBibTex();
};
