/***************************************************************************
 *                                                                         *
 *   bibtexfactory.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef BibTexFactory_h
#define BibTexFactory_h

#include <qstring.h>


class QSqlCursor;



class BibTexFactory {
 private:
  BibTexFactory(const BibTexFactory&);

 public:
  BibTexFactory(QSqlCursor &cur);
  QString getEntry();

 protected:
  QString entry;
  QString ascii2latex(QString &t);
  void start(QString label, QString ptype);
  void end();
  void addAddress(QString &s);
  void addAuthor(QString &s);
  void addBooktitle(QString &s);
  void addChapter(QString &s);
  void addEdition(QString &s);
  void addEditor(QString &s);
  void addHowpublished(QString &s);
  void addInstitution(QString &s);
  void addJournal(QString &s);
  void addMonth(QString &s);
  void addNote(QString &s);
  void addNumber(QString &s);
  void addOrganization(QString &s);
  void addPages(QString &s);
  void addPublisher(QString &s);
  void addSchool(QString &s);
  void addSeries(QString &s);
  void addTitle(QString &s);
  void addType(QString &s);
  void addVolume(QString &s);
  void addYear(QString &s);
  void addKey(QString &s);
  void addCrossRef(QString &s);
};

class PublBibTexFactory: public BibTexFactory {
 private:
  PublBibTexFactory(const BibTexFactory&);
  QString entry;

 public:
  PublBibTexFactory(QSqlCursor &cur);
};

class PartBibTexFactory: public BibTexFactory {
 private:
  PartBibTexFactory(const BibTexFactory&);
  QString entry;

 public:
  PartBibTexFactory(QSqlCursor &cur);
};  

#endif
