/***************************************************************************
 *                                                                         *
 *   createhtml.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
 ** ui.h extension file, included from the uic-generated form implementation.
 **
 ** If you wish to add, delete or rename functions or slots use
 ** Qt Designer which will update this file, preserving your code. Create an
 ** init() function in place of a constructor, and a destroy() function in
 ** place of a destructor.
 *****************************************************************************/
#include <qfiledialog.h>
#include <qsqlcursor.h>
#include <qregexp.h>
// #include <kmdcodec.h>
#include <qprocess.h>
#include <qapplication.h>
void CreateHtml::init() {
    
}

void CreateHtml::close()
{
  QWidget::close();
}

void CreateHtml::chooseDir()
{
  QString d=QFileDialog::getExistingDirectory(QString::null, this, "Choose a directoy");
  if(d!=QString::null) dir->setText(d);
}

QString CreateHtml::createHeader(QString title, QString menu) {
  QString i;
  i+="<html><head><title>";
  i+=title;
  i+="</title>";
  i+="<link rel=\"stylesheet\" type=\"text/css\" href=\"formate.css\"></head><body>";
  i+="<a href=\"index.html\">Home</a> &nbsp;";
  i+="<a href=\"publindex.html\">Publication Index</a> &nbsp;";
  i+="<a href=\"noteindex.html\">Note Index</a> &nbsp;";    
  i+="<a href=\"authorindex.html\">Author Index</a> &nbsp;";    
  i+="<h1 class=\"maintitle\">"+title+"</h1><br>";
  return i;
}
	

QString CreateHtml::createLinkList(QString query, QString title) {
  QString s;
  QSqlQuery q(query);
  if(q.size()<1) return s;
  s+="<h2 class=\"subtitle\">"+title+"</h2>";
  s+="<ul class=\"main\">";
  while(q.next()) {
    s+="<li><a href=\""+q.value(1).toString()+".html\">";
    s+=q.value(0).toString()+"</a>";
  }
  s+="</ul>";
  return s;
}

QString CreateHtml::createMemo(QString memo) {
  QString s;
  s+="<h2 class=\"subtitle\">Memo</h2><br>";
  s+="<div class=\"note\">";
  s+=memo.remove(QRegExp("<html>|</html>|<body[^>]*>|</body>|<head>|</head>"));
  s+="</div><br><br>";
  return s;
}    

void CreateHtml::exportAuthors() {
  QSqlCursor cur("author");
  cur.select(cur.index("lastname"));
  progr_author->setTotalSteps(cur.size());
  QString index("<html><header><title>Author Index</title>");
  index+="<link rel=\"stylesheet\" type=\"text/css\" href=\"formate.css\"></header><body>";
  index+="<h1 class=\"maintitle\">Author Index</h1>";
  while(cur.next()) {
    qApp->processEvents();
    QString path=dir->text()+"/"+cur.value("no").toString()+".html";
    index+="<a href=\""+path+"\">"+cur.value("lastname").toString()+", "+cur.value("firstname").toString()+"</a><br>";
    QFile file(path);
    if ( file.open( IO_WriteOnly ) ) {
      progr_author->setProgress(cur.at()+1);
      QTextStream stream( &file );
      stream<<createHeader(cur.value("firstname").toString()+" "+cur.value("lastname").toString(), "<a href=\"authorindex.html\">Author Index</a>");
      stream<<"<ul class=\"main\">";
      stream<<"<li><b>born:</b>"+cur.value("born").toString()+"</li>";
      stream<<"<li><b>decesed:</b>"+cur.value("died").toString()+"</li>";
      stream<<"<li><b>pseudonym:</b>"+cur.value("pseudonym").toString()+"</li>";
      stream<<"<li><b>country:</b>"+cur.value("country").toString()+"</li>";
      stream<<"</ul>";

	    
      stream<<createLinkList("select publication.title, publication.no from publication, publication_author where publication.no=publication_author.publication_no and publication_author.author_no="+cur.value("no").toString()+" order by title", "Publications");

      stream<<createLinkList("select part.title, part.no from part, part_author where part.no=part_author.part_no and part_author.author_no="+cur.value("no").toString()+" order by title", "Parts");
	    
      stream<<createLinkList("select note.title, note.no from note, link where (link.obj_1="+cur.value("no").toString()+" and link.obj_2=note.no) or (link.obj_2="+cur.value("no").toString()+" and link.obj_1=note.no) order by title", "Notes");
      stream<<createMemo(cur.value("memo").toString());
      stream<<html_footer;
      stream<<"</body></html>";
      file.close();
    }
  }
  index+"</body></html>";
  QFile ifile(dir->text()+"/authorindex.html");
  if ( ifile.open( IO_WriteOnly ) ) {
    QTextStream stream( &ifile );
    stream<<index;
  }
  ifile.close();
}

void CreateHtml::exportPublications() {
  QSqlCursor cur("publication");
  cur.select(cur.index("title"));
  progr_publ->setTotalSteps(cur.size());
  QString index("<html><header><title>Publication Index</title>");
  index+="<link rel=\"stylesheet\" type=\"text/css\" href=\"formate.css\"></header><body>";
  index+="<h1 class=\"maintitle\">Publication Index</h1>";
  while(cur.next()) {
    qApp->processEvents();	
    QString path=dir->text()+"/"+cur.value("no").toString()+".html";
    index+="<a href=\""+path+"\">"+cur.value("title").toString()+"</a><br>";
    QFile file(path);
    if ( file.open( IO_WriteOnly ) ) {
      progr_publ->setProgress(cur.at()+1);
      QTextStream stream( &file );
      stream<<createHeader(cur.value("title").toString(), "<a href=\"publindex.html\">Publication Index</a>");
      stream<<"<ul class=\"main\">";
      stream<<"<li><b>Year:</b>"+cur.value("year").toString()+"</li>";
      QSqlQuery q("select publisher.name from publisher where publisher.no="+cur.value("publisher_no").toString());
      if(q.first())
	stream<<"<li><b>Publisher:</b>"+q.value(0).toString()+"</li>";
      stream<<"</ul>";

	    
      stream<<createLinkList("select author.firstname ||' '|| author.lastname as name, author.no from author, publication_author where author.no=publication_author.author_no and publication_author.publication_no="+cur.value("no").toString()+" order by author.lastname", "Authors");

      stream<<createLinkList("select part.title, part.no from part where part.publication_no="+cur.value("no").toString()+" order by part.title", "Parts");
	    
      stream<<createLinkList("select note.title, note.no from note, link where (link.obj_1="+cur.value("no").toString()+" and link.obj_2=note.no) or (link.obj_2="+cur.value("no").toString()+" and link.obj_1=note.no) order by title", "Notes");
	    
      stream<<createMemo(cur.value("memo").toString());
      stream<<html_footer;
      stream<<"</body></html>";
      file.close();
    }
  }
  index+"</body></html>";
  QFile ifile(dir->text()+"/publindex.html");
  if ( ifile.open( IO_WriteOnly ) ) {
    QTextStream stream( &ifile );
    stream<<index;
  }
  ifile.close();
}

void CreateHtml::exportNotes() {
  QSqlCursor cur("note");
  cur.select(cur.index("title"));
  progr_notes->setTotalSteps(cur.size());
  QString index("<html><header><title>Note Index</title>");
  index+="<link rel=\"stylesheet\" type=\"text/css\" href=\"formate.css\"></header><body>";
  index+="<h1 class=\"maintitle\">Note Index</h1>";
  while(cur.next()) {
    qApp->processEvents();	
    QString path=dir->text()+"/"+cur.value("no").toString()+".html";
    if(cur.value("type").toString()=="0" && cur.value("parent").toString()=="0")
      index+="<a href=\""+path+"\">"+cur.value("title").toString()+"</a><br>";
    QFile file(path);
    if ( file.open( IO_WriteOnly ) ) {
      progr_notes->setProgress(cur.at()+1);
      QTextStream stream( &file );
      stream<<createHeader(cur.value("title").toString(), "<a href=\"noteindex.html\">Note Index</a>");
	    
      QString no=cur.value("no").toString();
	    
      QSqlQuery q("select note.title, note.no from note where no="+cur.value("parent").toString()+"order by title");
      if(q.first())
	stream<<"<b>Parent Note:</b> <a href=\""+q.value(1).toString()+".html\">"+q.value(0).toString()+"</a>";
	    	    
      stream<<createLinkList("select note.title, note.no from note where parent="+no+"order by title", "Child Notes");
	    
      stream<<createLinkList("select note.title, note.no from note, link where (link.obj_1="+no+" and link.obj_2=note.no) or (link.obj_2="+no+" and link.obj_1=note.no) order by title", "Notes");
	    
      stream<<createLinkList("select author.firstname ||' '|| author.lastname, author.no from author, link where (author.no=link.obj_1 and link.obj_2="+no+") or (author.no=link.obj_2 and link.obj_1="+no+")", "Authors");
	    
      stream<<createLinkList("select publication.title, publication.no from publication, link where (publication.no=link.obj_1 and link.obj_2="+no+") or (publication.no=link.obj_2 and link.obj_1="+no+")", "Publications");
	    
      stream<<createLinkList("select part.title, part.no from part, link where (part.no=link.obj_1 and link.obj_2="+no+") or (part.no=link.obj_2 and link.obj_1="+no+")", "Parts");
	    
      stream<<createLinkList("select file.filename, file.no from file, link where (file.no=link.obj_1 and link.obj_2="+no+") or (file.no=link.obj_2 and link.obj_1="+no+")", "Files");
	    
      stream<<createMemo(cur.value("memo").toString());
      stream<<html_footer;
      stream<<"</body></html>";
      file.close();
    }
  }
  index+"</body></html>";
  QFile ifile(dir->text()+"/noteindex.html");
  if ( ifile.open( IO_WriteOnly ) ) {
    QTextStream stream( &ifile );
    stream<<index;
  }
  ifile.close();
}

void CreateHtml::exportParts() {
  QSqlCursor cur("part");
  cur.select(cur.index("title"));
  progr_parts->setTotalSteps(cur.size());
  while(cur.next()) {
    qApp->processEvents();	
    QString path=dir->text()+"/"+cur.value("no").toString()+".html";
    QFile file(path);
    if ( file.open( IO_WriteOnly ) ) {
      progr_parts->setProgress(cur.at()+1);
      QTextStream stream( &file );
      stream<<createHeader(cur.value("title").toString(), "");
      QSqlQuery q("select publication.title, publication.no from publication where publication.no="+cur.value("publication_no").toString());
      if(q.first())
	stream<<"<b>Publication:</b><a href=\""+q.value(1).toString()+".html\">"+q.value(0).toString()+"</a>";
	    
      if(inclfiles->isChecked()) 
	stream<<createLinkList("select file.filename, file.no from file where file.part_no="+cur.value("no").toString(), "Files");
	    
      stream<<createLinkList("select note.title, note.no from note, link where (link.obj_1="+cur.value("no").toString()+" and link.obj_2=note.no) or (link.obj_2="+cur.value("no").toString()+" and link.obj_1=note.no) order by title", "Notes");
	    
      stream<<createMemo(cur.value("memo").toString());
      stream<<html_footer;
      stream<<"</body></html>";
      file.close();
    }
  }
}

void CreateHtml::exportFiles() {
  QSqlQuery cur("select no, type from partdata");
  progr_files->setTotalSteps(cur.size());
  while(cur.next()) {
    QString type=cur.value(1).toString();
    qApp->processEvents();
    QString path=dir->text()+"/"+cur.value(0).toString()+".html";
    progr_files->setProgress(cur.at()+1);
    QSqlQuery q("select file from file where no="+cur.value(0).toString());
    q.first();
    QCString buffer=q.value(0).toCString();
    QCString dec;
    //	KCodecs::base64Decode(buffer, dec);
    if(type=="text/html") {
      QFile file(path);
      if ( file.open( IO_WriteOnly ) ) {
	QTextStream stream( &file );
	stream<<dec;
	file.close();
      }
    }
    else if(type=="application/pdf") {
      //	    debug(buffer);
      convert("pdftohtml #in# #out#", dec, path);
    }
    else {
      QFile file(path);
      if(file.open( IO_WriteOnly)) {
	QTextStream stream( &file );
	stream<<"<html><head></head><body><h1>No HTML file!</h1></body></html>";
	file.close();
      }
    }
  }
}

void CreateHtml::exportStyleSheet() {
  QString path=dir->text()+"/formate.css";
  QFile file(path);
  if ( file.open( IO_WriteOnly ) ) {
    QTextStream stream( &file );
    stream<<"h1.maintitle { font-family:Arial,sans-serif; font-size:24pt; font-weight:normal; background-color:#AAAAFF;  border-bottom:solid thick black; text-align:center}\n";
    stream<<"ul.main { background-color:#DDDDDD }\n";
    stream<<"ul.links { background-color:#DDDDDD }\n";	
    stream<<"h2.subtitle { font-family:Arial,sans-serif; font-size:18pt; font-weight:normal; border-bottom:solid thick black }\n";
    stream<<".note {    font-family:Arial,sans-serif;  font-size:12pt; font-weight:normal }";
    file.close();
  }
}

void CreateHtml::exportIndex() {
  QString path=dir->text()+"/index.html";
  QFile file(path);
  if ( file.open( IO_WriteOnly ) ) {
    QTextStream stream( &file );
    stream<<"<html><head><title>Home</title></head><body>\n";
    stream<<"<a href=\"publindex.html\">Publication Index</a> &nbsp;";
    stream<<"<a href=\"noteindex.html\">Note Index</a> &nbsp;";    
    stream<<"<a href=\"authorindex.html\">Author Index</a> &nbsp;";    
    stream<<"</body></html>";
    file.close();
  }
    
}

void CreateHtml::convert(QString cmd, QByteArray in, QString outfilename) {
    
  QString infilename=tmpnam(0L);
  QFile infile(infilename);
  infile.open(IO_WriteOnly);
  infile.writeBlock(in);
  infile.close();
  QProcess proc(this);
  cmd.replace(QRegExp("#in#"), infilename);
  cmd.replace(QRegExp("#out#"), outfilename);
    
  /*
    connect(&proc, SIGNAL(receivedStderr (KProcess*,char*,int)),
    this, SLOT(slotReceivedStderr (KProcess*,char*,int)) );
    connect(&proc, SIGNAL(receivedStdout (KProcess*,char*,int)),
    this, SLOT(slotReceivedStdout (KProcess*,char*,int)) );
  */
    
  proc.addArgument("sh");
  qDebug("Executing \""+QString(cmd)+"\"\n");
  proc.addArgument(cmd);
  //  proc<<"html2text /tmp/test.html > /tmp/test.txt";
  proc.start();
  while(proc.isRunning()) {
    qApp->processEvents();
  }
    
  qDebug("\nConvert2Text, exitstatus:"+QString().setNum(proc.exitStatus())+"\n");
    
  /*
    if(!proc.normalExit())
    throw KaspaErr("Conversion process: Abnormal termination!");
  */
  infile.remove();
}



void CreateHtml::start()
{
  exportAuthors();
  exportNotes();
  exportPublications();
  exportParts();    
//  exportFiles();
  exportStyleSheet();
  exportIndex();
}

void CreateHtml::stop()
{
  
}

void CreateHtml::newFunction()
{
  
}
