/***************************************************************************
 *                                                                         *
 *   dragnoteslistview.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef dragnoteslistview_h
#define dragnoteslistview_h

#include <qlistview.h>
#include <qdragobject.h>
#include "notetreeitem.h"

class DragNotesListView: public QListView {
    Q_OBJECT
    
    public:
    DragNotesListView(QWidget *parent=0, const char *name=0,WFlags f = 0): QListView(parent, name, f) {};
    
    protected:
    virtual QDragObject *dragObject() {
	NoteTreeItem *i=dynamic_cast<NoteTreeItem*>(currentItem());
	Q_ASSERT(i);
	return new QTextDrag(i->url(), this);
    }
};

#endif
