/***************************************************************************
 *                                                                         *
 *   file.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "fileform.h"
#include "readwriteformbase.h"

#ifdef HAS_KDE
#include <kparts/part.h>
#endif

class QToolBar;
class FillLinkListBox;
class MainWindow;
class QCloseEvent;
class File: public ReadWriteFormBase {
    Q_OBJECT

    private:
    File(const File&);
    File& operator=(const File&);

    protected:
    FileForm *fileform;
    QToolBar *toolbar;
    QAction *insertNoteAction;
    QAction *createNoteAction;    
    QAction *deleteNoteAction;
    QAction *runApplicationAction;
    QAction *addToProjectAction;

#ifdef HAS_KDE
    KParts::ReadOnlyPart *part;
    QString kio_target;
    QString file;
#endif

    FillLinkListBox *filllink;
    bool setData();
    
    void initToolBar();
    
    public:
    File(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~File();
    
    protected slots:    
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    virtual void insertNote();
    virtual void deleteNote();
    virtual void createNote();  
    virtual void addToProject();
#ifdef HAS_KDE
    virtual void runApp();
#endif
};
