/***************************************************************************
 *                                                                         *
 *   filllinklistbox.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef FillLinkListBox_h
#define FillLinkListBox_h
#include <qobject.h>
#include <qthread.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qvaluelist.h>
#include <qmutex.h>

class LinkListBox;
class QListViewItem;

/** Fills a linklistbox with data. Uses its own thread so it doesn't block die gui.
     Sends an Event "ThreadFinishedEvent" when finished.
  */
class FillLinkListBox: public QThread {
    
 protected:
  QObject *parent;           
  QString name;
  LinkListBox *box;    
  QString query;  
  QString cmd; 
  QPixmap pixm;
  QListViewItem *parentitem;
  
  void run();
  
 public:
  /**@param parent - receives the "ThreadFinishedEvent"
     @param name - identifies the object
     @param box - box to fill
     @param query - sql query to execute. Must include the "no" field. The other fields 
     are used to fill the box in their order of appereance.
     @param cmd - command for the filllinklistboxitem
  */
  FillLinkListBox(QObject *parent, QString name, LinkListBox *box, QString query, QString cmd, QPixmap pm=QPixmap(), QListViewItem *parentitem=0L);
  ~FillLinkListBox();
};

#endif
