/***************************************************************************
 *                                                                         *
 *   generatebibtex.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void GenerateBibTex::chooseFile() {
    QFileDialog* fd = new QFileDialog( this );
    if (fd->exec() == QDialog::Accepted)         
	filename->setText(fd->selectedFile());
}

void GenerateBibTex::setProjectNo(QString n) {
  project=n;
}

void GenerateBibTex::generateBibTex() {
    QFile f(filename->text());
    if(f.open(IO_WriteOnly)) {
      QTextStream s(&f);
      QSqlQuery q("select p.bibtex, p.title from part p, project_bibliography b where b.project_no="+project+" and tab_no=tabid('part') and p.no=b.id_no");
      progress->setTotalSteps(q.size());
      int i=0;
     while(q.next()) {
       i++;
       progress->setProgress(i);
       s<<q.value(0).toString()<<"\n";       
       log->append(q.value(1).toString()+"\n");
    }
    
    q.exec("select p.bibtex, p.title from publication p, project_bibliography b where b.project_no="+project+" and tab_no=tabid('publication') and b.id_no=p.no union select publ.bibtex, publ.title from publication publ, part, project_bibliography b where b.project_no="+project+" and b.tab_no=tabid('part') and part.no=b.id_no and publ.no=part.publication_no");
    progress->setTotalSteps(q.size());    
    i=0;
    while(q.next()) {
       i++;
       progress->setProgress(i);	
       s<<q.value(0).toString()<<"\n";
       log->append(q.value(1).toString()+"\n");
    }
    f.close();    
  }
}
