/***************************************************************************
 *                                                                         *
 *   global.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "global.h"
#include <qpixmap.h>
#include <qimage.h>
#include <qdragobject.h>
#include <qstring.h>
#include <qsqldatabase.h>
#include "dbdata.h"

QIntDict<bool> locked_recs_dict;
// locked_recs_dict.setAutoDelete(true);

// void qInitImages_literature();
// extern QMimeSourceFactory* factory;

QPixmap loadPixmap( const QString &name )
{
  const QMimeSource *m = QMimeSourceFactory::defaultFactory()->data( name );
  //  qInitImages_literature();
  // const QMimeSource *m = factory->data(name);
  if ( !m )
    return QPixmap();
  QPixmap pix;
  QImageDrag::decode( m, pix );
  return pix;
}

bool createConnection(QString conn_name)
{
  // create the default database connection
  
  QSqlDatabase *db = QSqlDatabase::addDatabase( SQL_DRIVER, conn_name);
  if ( ! db ) {
    qWarning( "Failed to connect to driver" );
    return FALSE;
  }
  db->setDatabaseName( DB_NAME );
  db->setUserName( DB_USER );
  db->setPassword( DB_PASSWD );
  db->setHostName( DB_HOST );
  if ( ! db->open() ) {
    qWarning( "Failed to open database: " +
	      db->lastError().driverText() );
    qWarning( db->lastError().databaseText() );
    return FALSE;
  }
  return true;
}
