/***************************************************************************
 *                                                                         *
 *   importjstorbib.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qtextstream.h>
#include <qstring.h>
#include <qregexp.h>
#include <qsqlquery.h>
#include <qstringlist.h>

void ImportJStorBib::init() {
}


void ImportJStorBib::setEntry(QString entry) {
  QTextStream stream(&entry, IO_ReadWrite);
  QString line;
  while (!stream.atEnd()) {
    line = stream.readLine();
    QString data=line.right(line.length()-4);
    if(line.find(QRegExp("^TI :"))>-1) title->setText(data);
    if(line.find(QRegExp("^AU :"))>-1) {
      QStringList au;
      au.split(";",line);
      int i=0;
      QStringList authorlist;
      QSqlQuery q;
      q.exec("select firstname, lastname from author order by lastname");

      while(q.next())
	authorlist+=q.value(1).toString()+q.value(0).toString();

      for (QStringList::Iterator it = au.begin(); it != au.end(); ++it ) {
	QString lastname=(*it).left((*it).find(","));
	QString firstname=(*it).right((*it).length()-(*it).find(","));
	authors->setText(1,i,firstname);
	authors->setText(2,i,lastname);
	authors->setItem(3,i,new QComboTableItem(authors, authorlist));
	authors->setItem(4,i,new QCheckTableItem(authors, "Insert existing author:"));
      }
    }
    if(line.find(QRegExp("^SO :"))>-1) journal->setText(data);
    if(line.find(QRegExp("^VO :"))>-1) volume->setText(data);
    if(line.find(QRegExp("^NO :"))>-1) number->setText(data);
    if(line.find(QRegExp("^DA :"))>-1) date->setText(data);
    if(line.find(QRegExp("^PP :"))>-1) pages->setText(data);
    if(line.find(QRegExp("^AB :"))>-1) abstract->setText(data);
    if(line.find(QRegExp("^PB :"))>-1) publisher->setText(data);
  }
}

