/***************************************************************************
 *                                                                         *
 *   importjstorwizard.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void ImportJStorWizard::init() {
  widget=new ImportJStorFile(this);
  widget->show();
}

void ImportJStorWizard::next() {
  ImportJStorFile *f=dynamic_cast<ImportJStorFile*>(widget);
  if(f) {
    QString filename=f->filename->text();
    QFile file;
    file.setName(filename);
    if(!file.open(IO_ReadOnly)) {
      QMessageBox::information(this, "Import JStor", "Cannot open file.");
      return;
    }
    QString buffer=file.readAll();
    count=0;
    entries.split(QRegExp("<\\d+>"), buffer);
    file.close();
    widget=new ImportJStorBib(this, entries[0]);
    count++;
    widget->show();
    return; 
  }

  ImportJStorBib *b=dynamic_cast<ImportJStorBib*>(widget);
  if(b) {
    /*
      QSqlQuery q;
      q.exec("");
      b->title->text();
    */

    if(entries[count]) {
      ImportJStorBib *b=new ImportJStorBib(this);
      b->setEntry(entries[count]);
      b->show();
      count++;
    }
    else
      close();
  }
}
