/***************************************************************************
 *                                                                         *
 *   journal.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef JournalForm_h
#define JournalForm_h
#include "journalform.h"
#include "readwriteformbase.h"

class QToolBar;
class QAction;
class MainWindow;

class Journal: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Journal(const Journal&);
    Journal& operator=(const Journal&);

    protected:
    JournalForm *journalform;
    bool setData();
    
    public:
    Journal(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Journal();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
};
#endif
