/***************************************************************************
 *                                                                         *
 *   linklistbox.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef LINKLISTBOX_H
#define LINKLISTBOX_H
#include <qlistview.h>
#include <qpopupmenu.h>
class LitUrl;
class LinkListBoxItem;

class LinkListBox: public QListView  {
   Q_OBJECT

private:
	LinkListBox(const LinkListBox&);
	LinkListBox& operator=(const LinkListBox&);

protected:		
	QPopupMenu pop;
//	QPoint mousePos;
	
public:
	LinkListBox(QWidget *parent=0, const char *name=0);
	~LinkListBox();
	LitUrl url();
	
	
signals:
	void open(QString where, const char *data, bool);
	void open(QString where, bool);	
	
protected slots:
	void slotSelected(QListViewItem *item);
	void slotOpen();
	void slotNewWindow();
	void slotPopupMenu(QListViewItem *item, const QPoint& p, int c);
             void open(bool newwin);
};
#endif
