/***************************************************************************
 *                                                                         *
 *   linklistboxitem.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef LinkListBoxItem_h
#define LinkListBoxItem_h
#include <qlistview.h>
#include "liturl.h"
#include <qcolor.h>
#include <qpalette.h>
#include <qpixmap.h>

class LinkListBoxItem : public QListViewItem  {
    LitUrl u;
    QColor textcolor;
    QColor backgrcolor;
    QString orderprefix;
    
public:
  LinkListBoxItem(QListView *listbox, QString title, LitUrl url, QPixmap pm=QPixmap());
  LinkListBoxItem(QListView *listbox, LitUrl url, QListViewItem *after,  QPixmap pm=QPixmap());
  LinkListBoxItem(QListViewItem *parent, QString title, LitUrl url, QPixmap pm=QPixmap());
  LinkListBoxItem(QListViewItem *parent, LitUrl url, QListViewItem *after,  QPixmap pm=QPixmap());
  void init();
  void  paintCell(QPainter *p, const QColorGroup &cg, int column, int width, int alignment);
  LitUrl url();  
  void setTextColor(const QColor& c);
  void setBackgroundColor(const QColor& c);	
  void setOrderPrefix(QString p);
  virtual const QString key(int column, bool ascending);    
  ~LinkListBoxItem();
};
#endif
