/***************************************************************************
 *                                                                         *
 *   liturl.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "liturl.h"
#include <qstring.h>
#include <stdlib.h>

LitUrl::LitUrl():QUrl() {  };
LitUrl::LitUrl(const QUrl &url):QUrl(url) { 
  if(fileName().isEmpty() || host().isEmpty()) {
    debug("LitUrl - filename oder host empty:"+url);
    abort();
  }
}
LitUrl::LitUrl(const QString &url):QUrl(url) { 
  if(fileName().isEmpty() || host().isEmpty()) {
    debug("LitUrl - filename oder host empty:"+url);
    abort();
  }
};

QString LitUrl::table() { return fileName(); }

QString LitUrl::where() { return query(); }
QString LitUrl::form() { return host(); }
