/***************************************************************************
 *                                                                         *
 *   main.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifdef HAS_KDE
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#else
#include <qapplication.h>
#endif
#include "mainwindowimpl.h"
#include "global.h"
#include <qsqlquery.h>
#include <qurl.h>
#include <qmime.h>

#include <kglobal.h>
#include <kstandarddirs.h>


int main( int argc, char ** argv )
{
  printf("This program is free software; you can redistribute it and/or modify\n" \
	 "it under the terms of the GNU General Public License as published by\n" \
	 "the Free Software Foundation; either version 2 of the License, or   \n" \
	 "(at your option) any later version.                                 \n" \
	 "Read the file COPYING for details.				      \n" \
	 "Copyright: (C) 2003-2004 by Jan Mueller		              \n" \
	 "Email: janmueller7@hotmail.com\n");

  KAboutData about("Literature", "Literature", "0.1", "A Literature Database", KAboutData::License_GPL, "(C) Jan Mller 1999-2003 ");
  KCmdLineArgs::init(argc, argv, &about);
  KApplication a( argc, argv );

	KGlobal::dirs()->addResourceType("LT_pic", "share/apps/literature/pics/");

  if ( !createConnection("qt_sql_default_connection") || !createConnection("threadConnection"))
    return 1;
  //    QSqlQuery("set client_endcoding to 'unicode'");
  MainWindowImpl *w = new MainWindowImpl;

  w->show();
  a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );

  return a.exec();
}
