/***************************************************************************
 *                                                                         *
 *   mainwindow.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/
#include "authoroverview.h"
#include "urlevent.h"
#include "qapplication.h"
#include <qsqlquery.h>

#include <kiconloader.h>

void MainWindow::init()
{ 
     urlline = new QLineEdit(navtoolbar);
     connect(urlline, SIGNAL(returnPressed()), this, SLOT(urlEntered()));
 }

void MainWindow::fileExit()
{
    qApp->exit();
}

void MainWindow::editCut()
{

}

void MainWindow::editCopy()
{

}

void MainWindow::editPaste()
{

}

void MainWindow::editFind()
{

}

void MainWindow::helpIndex()
{

}

void MainWindow::helpContents()
{

}

void MainWindow::helpAbout()
{

}


void MainWindow::showAuthor( LitUrl url )
{
}

void MainWindow::forward()
{
}


void MainWindow::back()
{
}


void MainWindow::createAuthor()
{
    QSqlQuery q("select create_author() as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://author/author?no="+q.value(0).toString()), false));
}

void MainWindow::createPublication()
{
    QSqlQuery q("select create_publication() as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://publication/publication?no="+q.value(0).toString()), false));
}

void MainWindow::createProject()
{
    QSqlQuery q("select create_project() as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://project/project?no="+q.value(0).toString()), false));
}


void MainWindow::createNote()
{
    QSqlQuery q("select create_toplevel_note(0) as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://note/note?no="+q.value(0).toString()), false));
}


void MainWindow::createJournal()
{
    QSqlQuery q("select create_journal() as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://journal/journal?no="+q.value(0).toString()), false));
}

void MainWindow::createPublisher()
{
    QSqlQuery q("select create_publisher() as no");
    q.first();
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://publisher/publisher?no="+q.value(0).toString()), false));
}


void MainWindow::setWorkingGui( bool block )
{
    backAction->setEnabled(!stback.isEmpty()&&!block);
    forwardAction->setEnabled(!stforward.isEmpty()&&!block);
    createAuthorAction->setEnabled(!block);
    createPublAction->setEnabled(!block);
    createPartAction->setEnabled(!block);
    createJournalAction->setEnabled(!block);
    createPublisherAction->setEnabled(!block);
    createNoteAction->setEnabled(!block);
    stateAction->setEnabled(!block);
    searchAction->setEnabled(!block);    
    authorOverviewAction->setEnabled(!block);
    publOverviewAction->setEnabled(!block);
    noteOverviewAction->setEnabled(!block);
    publisherOverviewAction->setEnabled(!block);
    journalOverviewAction->setEnabled(!block);
    urlline->setEnabled(!block);    
}

void MainWindow::state()
{
  qApp->postEvent(this, new UrlEvent(LitUrl("lit://state/state"), false));
}

void MainWindow::search()
{
  qApp->postEvent(this, new UrlEvent(LitUrl("lit://search/search"), false));    
}


void MainWindow::authorOverview()
{
  qApp->postEvent(this, new UrlEvent(LitUrl("lit://authoroverview/authoroverview"), false));    
}


void MainWindow::noteOverview()
{
 qApp->postEvent(this, new UrlEvent(LitUrl("lit://noteoverview/noteoverview"), false));
}

void MainWindow::journalOverview()
{
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://journaloverview/journaloverview"), false));
}

void MainWindow::publisherOverview()
{
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://publisheroverview/publisheroverview"), false));
}

void MainWindow::projectOverview()
{
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://projectoverview/projectoverview"), false));
}

void MainWindow::publOverview()
{
    qApp->postEvent(this, new UrlEvent(LitUrl("lit://publicationoverview/publicationoverview"), false));
}

void MainWindow::urlEntered()
{
    qApp->postEvent(this, new UrlEvent(LitUrl(urlline->text()), false));
}

void MainWindow::exportHtml()
{
    CreateHtml *d=new CreateHtml();
    d->show();
}

void MainWindow::reindex() {
    ReIndex r;
    r.show();
    r.start();
}

void MainWindow::importJStor()
{
    ImportJStorWizard *d=new ImportJStorWizard();
    d->show();
}
