/***************************************************************************
 *                                                                         *
 *   note.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef NoteForm_h
#define NoteForm_h
#include "noteform.h"
#include "readwriteformbase.h"

class QToolBar;
class QAction;
class FillLinkListBox;
class MainWindow;
class QListViewItem;

class Note: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Note(const Note&);
    Note& operator=(const Note&);

    protected:
    NoteForm *noteform;
    QToolBar *toolbar;
    FillLinkListBox *filllink_note;
    FillLinkListBox *filllink_author;
    FillLinkListBox *filllink_publ;
    FillLinkListBox *filllink_part;    
    FillLinkListBox *filllink_partdata;    
    bool setData();

    QAction *insertNoteAction;
    QAction *deleteNoteAction;
    
    void initToolBar();
    QListViewItem *addNoteTree(QString where, QListViewItem *par=0L, bool emph=false);
    public:
    Note(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Note();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    
    public slots:
    virtual void deleteRec();	    
    virtual void insertNote();
    virtual void deleteNote();
	    
};
#endif
