/***************************************************************************
 *                                                                         *
 *   noteoverview.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "noteoverview.h"
#include <qlabel.h>
#include <qsqlquery.h>
#include <qlayout.h>
#include <qaction.h>
#include "global.h"

NoteOverview::NoteOverview(LitUrl u, QObject *receiver, QString slot, QWidget *parent, const char *name): ReadOnlyFormBase(u, receiver, slot, parent, name) {
    noteoverviewform=new NoteOverviewForm(this, "NoteOverviewForm");
    Q_ASSERT(noteoverviewform);
    QHBoxLayout *l=new QHBoxLayout(this);
    l->addWidget(noteoverviewform);
    setValid(true);
    noteoverviewform->setData(false);
    
    showPublsAction=new QAction("Show Publications", QIconSet(loadPixmap("showpubl.png")), "Show Publications", 0, this, "showpubls", true);
    connect(showPublsAction, SIGNAL(activated()), this, SLOT(showPubls()));
    showPublsAction->addTo(rotoolbar);
}

void NoteOverview::showPubls() {
    setData();
}

bool NoteOverview::setData() {
  Q_ASSERT(noteoverviewform);    
  noteoverviewform->setData(showPublsAction->isOn());
  return true;
}

NoteOverview::~NoteOverview() {
}



