/***************************************************************************
 *                                                                         *
 *   noteoverview.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef NoteOverview_h
#define NoteOverview_h
#include <qpopupmenu.h>
#include "liturl.h"
#include <qptrlist.h>
#include "readonlyformbase.h"
#include "noteoverviewform.h"

class NoteTreeItem;
class NoteOverview : public ReadOnlyFormBase {
    Q_OBJECT

private:
	NoteOverview(const NoteOverview&);
	NoteOverview& operator=(const NoteOverview&);
	QPopupMenu pop1;
	QPopupMenu pop2;
	bool showleafs;
	NoteOverviewForm *noteoverviewform;

protected:
	LitUrl url;
	QAction *showPublsAction;
	bool setData();

protected slots:	
	void showPubls();
	
public:

  NoteOverview(LitUrl u, QObject *receiver, QString slot, QWidget *parent=0, const char *name=0);
  virtual ~NoteOverview();

};
#endif 
