/***************************************************************************
 *                                                                         *
 *   notetreeitem.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef NoteTreeDlg_h
#define NoteTreeDlg_h

#include <qlistview.h>
#include "liturl.h"



class NoteTreeItem:public QListViewItem {

private:
	NoteTreeItem(const NoteTreeItem&);
	NoteTreeItem& operator=(const NoteTreeItem&);
	LitUrl _url;
	bool publnote;
	int parent;
	int sibling;
	
public:
	NoteTreeItem (NoteTreeItem *p, LitUrl u, const char *theText, QPixmap pm=QPixmap(), int parent=0, int sibling=0):
		QListViewItem(p, theText), _url(u), publnote(publnote), parent(parent), sibling(sibling)  { setPixmap(0, pm); };

  NoteTreeItem (QListView *p, LitUrl u, const char *theText, QPixmap pm=QPixmap(), int parent=0, int sibling=0):
		QListViewItem(p, theText), _url(u), publnote(publnote), parent(parent), sibling(sibling)  { setPixmap(0, pm); };

  	
	LitUrl url() { return _url; }
	int getParent() { return parent; }
	int getSibling() { return sibling; }
	
    };	

#endif



