/***************************************************************************
 *                                                                         *
 *   part.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef PartForm_h
#define PartForm_h
#include "partform.h"
#include "readwriteformbase.h"
#include <qcstring.h>

class QToolBar;
class QAction;
class FillLinkListBox;
class MainWindow;


class Part: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Part(const Part&);
    Part& operator=(const Part&);

    protected:
    PartForm *partform;
    QToolBar *toolbar;
    QAction *showPartMemoAction;
    QAction *insertNoteAction;
    QAction *createNoteAction;    
    QAction *deleteNoteAction;
    QAction *insertAuthorAction;
    QAction *createAuthorAction;    
    QAction *deleteAuthorAction;
    QAction *showPartPublAction;
    QAction *importFilesAction;
    QAction *addToProjectAction;

    FillLinkListBox *filllink;
    FillLinkListBox *fillauthor;
    FillLinkListBox *fillfiles;
    bool setData();
    void writebuf(QByteArray buf, int chunkno, QString fileno);    
    void initToolBar();
    virtual void write();
    
    public:
    Part(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Part();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);

    virtual void showPartMemo();
    virtual void showPartPubl();
    virtual void insertNote();
    virtual void deleteNote();
    virtual void createNote();
    virtual void insertAuthor();
    virtual void deleteAuthor();
    virtual void createAuthor();    
    virtual void generateBibTex();
    virtual void importFiles();
    virtual void addToProject();
};
#endif
