/***************************************************************************
 *                                                                         *
 *   partmemo.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef PartMemoForm_h
#define PartMemoForm_h
#include "partmemoform.h"
#include "readwriteformbase.h"

class QToolBar;
class QAction;
class MainWindow;

class PartMemo: public ReadWriteFormBase {
    Q_OBJECT

    private:
    PartMemo(const PartMemo&);
    PartMemo& operator=(const PartMemo&);

    protected:
    PartMemoForm *partmemoform;
    QToolBar *toolbar;
    bool setData();
    QAction *printAction;
    QAction *prAction;
    void initToolBar();
    
    public:
    PartMemo(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~PartMemo();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    virtual void print();
    virtual void pocketReader();
};
#endif
