/***************************************************************************
 *                                                                         *
 *   pocketreader.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void PocketReader::init() {
    if(cmd->text().isEmpty())
	cmd->setText("/usr/local/bin/pocketreader -batch -d /dev/ttyS0");
}

void PocketReader::start()
{
  debug("PocketReader::start()");
  QProcess proc(QString("sh"), this);
  proc.addArgument(QString("-c"));
  proc.addArgument(QString(cmd->text()));
  if(!proc.start()) {
    QMessageBox::warning(this, "Pocket Reader", "Cannot execute command!");
    return;
  }
  
  while(proc.isRunning()) qApp->processEvents();
  
  while(proc.canReadLineStderr())
    result->append(proc.readLineStderr());
  
  while(proc.canReadLineStdout())
    result->append(proc.readLineStdout());
  
  if(spellcheck->isChecked()) {
    QString s=result->text();
    KSpell::modalCheck(s);
    result->setText(s);
  }
}


void PocketReader::configSpellchecker()
{
  debug("PocketReader::configSpellchecker()");
  KSpellConfig s(0, "configspellcheck", 0, false);
  s.show();
}
