/***************************************************************************
 *                                                                         *
 *   project.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef Project_h
#define Project_h
#include "readwriteformbase.h"
#include "filllinklistbox.h"

class QToolBar;
class QAction;
class MainWindow;
class ProjectForm;
class FillLinkListBox;

class Project: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Project(const Project&);
    Project& operator=(const Project&);

    protected:
    ProjectForm *projectform;
    bool setData();
    void initToolBar();
    QToolBar *toolbar;
    QAction *insertPublAction;
    QAction *generateBibTexAction;
    QAction *deletePublAction;
    QAction *insertPartAction;
    FillLinkListBox *fillpubl;
    FillLinkListBox *fillpart;
    FillLinkListBox *fillfile;

    
    public:
    Project(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Project();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    virtual void insertPublication();
    virtual void insertPart();
    virtual void deletePublication();
    virtual void generateBibTex();
};
#endif
