/***************************************************************************
 *                                                                         *
 *   publication.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef PublicationForm_h
#define PublicationForm_h
#include "publicationform.h"
#include "readwriteformbase.h"

class QToolBar;
class QAction;
class FillLinkListBox;
class MainWindow;

class Publication: public ReadWriteFormBase {
    Q_OBJECT

    private:
    Publication(const Publication&);
    Publication& operator=(const Publication&);

    protected:
    PublicationForm *publform;
    QToolBar *toolbar;
    QAction *insertNoteAction;
    QAction *createNoteAction;    
    QAction *deleteNoteAction;
    QAction *createPartAction;    
    QAction *deletePartAction;
    QAction *insertAuthorAction;
    QAction *createAuthorAction;    
    QAction *deleteAuthorAction;
    QAction *showBiblioAction;
    QAction *addToProjectAction;
    
    FillLinkListBox *filllink;
    FillLinkListBox *fillauthor;
    FillLinkListBox *fillpart;
    bool setData();
    virtual void write();
    void initToolBar();
    
    public:
    Publication(LitUrl url, QObject *receiver, QString slot, MainWindow *parent, const char *name);
    ~Publication();
    
    protected slots:
    virtual void setWorkingGui(bool work);
    virtual void setReadonlyGui(bool ro);
    virtual void setInvalidGui(bool inv);
    
    virtual void showBiblio();
    virtual void insertNote();
    virtual void deleteNote();
    virtual void createNote();    
    virtual void insertAuthor();
    virtual void deleteAuthor();
    virtual void createAuthor();    
    virtual void createPart();
    virtual void deletePart();
    virtual void chooseJournal();
    virtual void choosePublisher();
    virtual void checkJournal();
    virtual void addToProject();
};
#endif
