/***************************************************************************
 *                                                                         *
 *   publoverview.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "publoverview.h"
#include "linklistbox.h"
#include "linklistboxitem.h"
#include <qlabel.h>
#include <qsqlquery.h>
#include <qlayout.h>
#include "liturl.h"

PublOverview::PublOverview(LitUrl u, QObject *receiver, QString slot, QWidget *parent, const char *name): ReadOnlyFormBase(u, receiver, slot, parent, name) {
    publoverviewform=new OverviewForm(this, "PublOverviewForm");
    Q_ASSERT(publoverviewform);
    QHBoxLayout *l=new QHBoxLayout(this);
    l->addWidget(publoverviewform);
    setData();
}

bool PublOverview::setData() {
  publoverviewform->title->setText("Publications");
  publoverviewform->linklistbox->clear();    
  publoverviewform->linklistbox->setColumnText(0, "Titles");
  QSqlQuery query("select title, no from publication order by title");
  
  while(query.next()) {
    new LinkListBoxItem(publoverviewform->linklistbox, query.value(0).toString(), LitUrl("lit://publication/publication?no="+query.value(1).toString()));
    setValid(true);
  }
  return true;
}    

PublOverview::~PublOverview() {
}
