/***************************************************************************
 *                                                                         *
 *   search.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef SEARCH_H
#define SEARCH_H

#include "readonlyformbase.h"
#include "searchform.h"
#include "fillsearchlist.h"
#include <qtimer.h>

class Search: public ReadOnlyFormBase {
   Q_OBJECT

private:
    Search(const Search&);
    Search& operator=(const Search&);
    SearchForm *searchform;
    FillSearchList *fillsearchlist;
    QTimer threadtimer;
    bool setData();
    void customEvent(QCustomEvent *e);

protected slots:
    virtual void startSearch();
    virtual void linkClicked(const QString &link);
    virtual void checkThreads();
    
public:
    Search(LitUrl u, QObject *receiver, QString slot, QWidget *parent=0, const char *name=0);
    ~Search();
};
#endif
