/***************************************************************************
 *                                                                         *
 *   selectitem.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void SelectItem::incrementalSearch( const QString& s )
{
  items->setCurrentItem(items->findItem(s, 0, Qt::BeginsWith));
  items->ensureItemVisible(items->findItem(s, 0, Qt::BeginsWith));
}


QString SelectItem::url()
{   
    if(!items->selectedItem()) return 0L;
    LinkListBoxItem *i=dynamic_cast<LinkListBoxItem*>(items->selectedItem());
    Q_ASSERT(i);
    return i->url();
}

QString SelectItem::text()
{   
    if(!items->selectedItem()) return 0L;
    LinkListBoxItem *i=dynamic_cast<LinkListBoxItem*>(items->selectedItem());
    Q_ASSERT(i);
    return i->text(0);
}


void SelectItem::setData(QString cmd, QString query)
{
  QSqlQuery q(query);
  QSqlRecord r=QSqlDatabase::database()->record(q);
  Q_ASSERT(r.position("no")!=-1);
  items->clear();
  items->addColumn("");
  items->setColumnText(0, "Names");
  
  while(q.next()) {
    QString str;
    for(unsigned int i=0; i<r.count(); i++) 
      if(r.fieldName(i)!="no")	 
        str+=q.value(i).toString()+" ";
    debug("SelectItem::setData():"+LitUrl("lit://"+cmd+"?no="+q.value(r.position("no")).toString()));
    new LinkListBoxItem(items, str, LitUrl("lit://"+cmd+"?no="+q.value(r.position("no")).toString()));
  }
}


void SelectItem::newFunction()
{

}
