/***************************************************************************
 *                                                                         *
 *   selectpart.ui.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include "liturl.h"

struct partrec {
  int     no;
  QString title;
  int     type;
  int     publication_no;
};

void SelectPart::init()
{
   parts->clear();
   QPtrList<partrec> n;
   QSqlQuery query("select no, title from publication order by title");
    while(query.next()) {
      partrec *r=new partrec;
      r->no=query.value(0).toInt();
      r->title=query.value(1).toString();
      r->type=1;
      r->publication_no=0;
      n.append(r);
    }

      query.exec("select part.no, part.title, part.publication_no from part order by title");
      while(query.next()) {
        partrec *r=new partrec;
        r->no=query.value(0).toInt();
        r->title=query.value(1).toString();
        r->type=2,
        r->publication_no=query.value(2).toInt();
        n.append(r);
      }

    addItem(n, 0, 0L);
    parts->geometry();
}

void SelectPart::addItem(QPtrList<partrec>& n, int parentoid, NoteTreeItem *parentitem) {
  QPtrListIterator<partrec> it(n);
  partrec *rec;
  while ((rec = it.current()) != 0 ) {
    ++it;
    if(rec->publication_no==parentoid) {
        NoteTreeItem *i;
    	  if(parentitem)
	      i=new NoteTreeItem(parentitem, LitUrl("lit://part/part?no="+QString().number(rec->no)), rec->title, loadPixmap("showpart.png"));
	      else
		  i=new NoteTreeItem(parts, LitUrl("lit://publication/publication?no="+QString().number(rec->no)), rec->title, loadPixmap("showpubl.png"));
       addItem(n, rec->no, i);
        n.remove(rec);
    }
  }
}


LitUrl SelectPart::url() {
    if(!parts->currentItem()) return LitUrl();
    NoteTreeItem *i=dynamic_cast<NoteTreeItem*>(parts->currentItem());
    Q_ASSERT(i);
    return i->url();
}


