/***************************************************************************
 *                                                                         *
 *   state.cpp								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#include "state.h"
#include "readonlyformbase.h"
#include <qglobal.h>
#include <qlabel.h>
#include <qsqlquery.h>
#include <qlayout.h>

State::State(LitUrl u, QObject *receiver, QString slot, QWidget *parent, const char *name): 
    ReadOnlyFormBase(u, receiver, slot, parent, name) {
    stateform=new StateForm(this, "stateform");
    QHBoxLayout *l=new QHBoxLayout(this);
    l->addWidget(stateform);
    Q_ASSERT(stateform);  
    setData();
}

bool State::setData() {
    QSqlQuery query("select count(*) from publication");
    query.first();
    stateform->publications->setText(query.value(0).toString()+" publications");
    
    query.exec("select count(*) from part");
    query.first();
    stateform->parts->setText(query.value(0).toString()+" parts");
    
    query.exec("select count(*) from author");
    query.first();
    stateform->authors->setText(query.value(0).toString()+" authors");
    
    query.exec("select count(*) from partdata");
    query.first();
    stateform->files->setText(query.value(0).toString()+" files");
    
    query.exec("select count(*) from note");
    query.first();
    stateform->notes->setText(query.value(0).toString()+" notes");
    
    query.exec("select count(*) from link");
    query.first();
    stateform->links->setText(query.value(0).toString()+" links");
    
    query.exec("select count(*) from publisher");
    query.first();
    stateform->publishers->setText(query.value(0).toString()+" publishers");
    
    setValid(true);
    return true;
}

State::~State() {
}
