/***************************************************************************
 *                                                                         *
 *   threadlinkevent.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef ThreadLinkEvent_h
#define ThreadLinkEvent_h
#include <qevent.h>
#include <qstring.h>
#include <qpixmap.h>
#include "liturl.h"

class LinkListBox;
class QListViewItem;
class ThreadLinkEvent: public QCustomEvent {
private:
	ThreadLinkEvent(const ThreadLinkEvent&);
	LinkListBox *_box;
	QString _text;
	QPixmap pixm;
	QListViewItem *parentitem;
	LitUrl u;
public:
	ThreadLinkEvent(LinkListBox *box, QString text, LitUrl url, QPixmap pm, QListViewItem *parentitem):QCustomEvent(User+2), _box(box), _text(text), pixm(pm), parentitem(parentitem), u(url) {
	}
	virtual ~ThreadLinkEvent() {  }
	
	LinkListBox *box() { return _box; }
	QString text() { return _text; }	
	QString url() { return u; }	
	QPixmap pixmap() { return pixm; }
	QListViewItem *parentItem() { return parentitem; }
};

#endif
