/***************************************************************************
 *                                                                         *
 *   urlevent.h								   *
 *									   *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   Read the file COPYING for details.					   *
 *									   *
 *   copyright: (C) 2003 by Jan Mueller					   *
 *   email: janmueller7@hotmail.com					   *
 *									   *
 ***************************************************************************/

#ifndef UrlEvent_h
#define UrlEvent_h
#include <qevent.h>
#include "liturl.h"

class UrlEvent : public QCustomEvent {
    private:
    LitUrl u;
    bool nw;
    UrlEvent(const UrlEvent&);

public:
    UrlEvent(LitUrl url, bool newwin):QCustomEvent(User), u(url), nw(newwin) {
    }
    UrlEvent(UrlEvent& e): QCustomEvent(User), u(e.url()), nw(e.nw) { }
    virtual ~UrlEvent() {  }
	
    LitUrl url() { return u; }
    bool newWin() { return nw; };
    void setNewWin(bool newwin) { nw=newwin; }
    void setUrl(LitUrl url) { u=url; }
};
   

#endif
